<?php

/************************************************************************************/
/*														*/
/*					   Menu : Themeswitcher						*/
/*					  ----------------------					*/
/*					     themeswitcher.php						*/
/*					  ----------------------					*/
/*														*/
/*	Date				: 16 Novembre 2008						*/
/*	Copyright			: (C) 2008 Viarre Rgis						*/
/*	Email				: crowkait@phpboost.com						*/
/*	Web				: http://www.phpboost.com					*/
/*	Version			: Menu Themeswitcher v.1.0.0					*/
/*														*/
/*	Compatible			: PhpBoost v.3.0							*/
/*														*/
/************************************************************************************/
/*														*/
/*	This program is free software; you can redistribute it and/or modify it 	*/
/*	under the terms of the GNU General Public License as published by the Free 	*/
/*	Software Foundation; either version 2 of the License, or (at your option) 	*/
/*	any later version.										*/
/*														*/
/*	This program is distributed in the hope that it will be useful, but WITHOUT	*/
/*	ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS */
/*	FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details	*/
/*														*/
/*	You should have received a copy of the GNU General Public License	along with	*/
/*	this program; if not, write to the Free Software Foundation, Inc., 		*/
/*	51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.			*/
/*														*/
/************************************************************************************/

/************************************************************************************/
/*														*/
/*					  ---------------------						*/
/*						Modifications						*/
/*					  ---------------------						*/
/*														*/
/*	Date				: 19 Mars 2012							*/
/*	Copyright			: 2012 PhpCraft (C)						*/
/*	Email				: phpcraft@live.fr						*/
/*	Version			: Menu Themeswitcher v.1.1.0					*/
/*														*/
/*	Compatible			: PhpBoost v.3.0							*/
/*														*/
/************************************************************************************/

/************************************************************************************/
/*														*/
/*	$Id: themeswitcher.php (*_*) Version : 1.1.0 - 19/03/2012 15:15 $phpcraft	*/
/*														*/
/************************************************************************************/

function menu_themeswitcher_themeswitcher($position, $block)
{
	global $CONFIG, $THEME_CONFIG, $User, $LANG, $Session;

	// ------------------------------
	// Chargement du fichier language
	//
	load_menu_lang('themeswitcher');

	// ----------------------
	// Configuration du thme
	//
	$switchtheme = !empty($_GET['switchtheme']) ? urldecode($_GET['switchtheme']) : '';
	if ( !empty($switchtheme) )
	{
		if ($User->check_level(MEMBER_LEVEL))
		{
			$Session->csrf_get_protect();
		}

		if ( preg_match('`[ a-z0-9_-]{3,20}`i', $switchtheme) && strpos($switchtheme, '\'') === false )
		{
			// -------------------------------------
			// Mise  jour du thme de l'utilisateur
			//
			$User->update_user_theme($switchtheme);
			if (QUERY_STRING != '')
			{
				redirect(trim(HOST . SCRIPT . '?' . preg_replace('`switchtheme=[^&]+`', '', QUERY_STRING), '?'));
			}
			else
			{
				redirect(HOST . SCRIPT);
			}
		}
	}

	// -------------------------
	// Chargement du fichier TPL
	//
	$tpl = new Template('menus/themeswitcher/themeswitcher.tpl');

	// -------------------------
	// Importation du block menu
	//
	import('core/menu_service');
	MenuService::assign_positions_conditions($tpl, $block);

	// ------------------
	// Slection du thme
	//
	$utheme = get_utheme();
	ksort($THEME_CONFIG);
	foreach($THEME_CONFIG as $theme => $array_info)
	{
		if ($User->check_level($array_info['secure']) && $theme != 'default')
		{
			$info_theme = @parse_ini_file(PATH_TO_ROOT . '/templates/' . $theme . '/config/' . get_ulang() . '/config.ini');
			$selected = ($utheme == $theme) ? ' selected="selected"' : '';

			// ---------------
			// Variable du TPL
			//
			$tpl->assign_block_vars('themes', array(
				'NAME' => $info_theme['name'],
				'IDNAME' => $theme,
				'SELECTED' => $selected
			));
		}
	}

	// ---------------
	// Variable du TPL
	//
	$tpl->assign_vars(array(
		'L_SWITCH_THEME' => $LANG['switch_theme'],
		'L_THEME_IDENTIFIER' => $utheme,
		'L_DEFAULT_THEME' => $LANG['default_theme'],
		'L_SUBMIT' => $LANG['submit'],

		'IMG_THEME_IDENTIFIER' => PATH_TO_ROOT . '/templates/' . $utheme . '/theme/images/theme.jpg',
		'DEFAULT_THEME' => $CONFIG['theme']
	));
	return $tpl->parse(TEMPLATE_STRING_MODE);
}

//
// Fin du fichier !
// ----------------

?>